/*****************************************************************

 test_myfpga.sv module

******************************************************************

 My Company Confidential Copyright  2012

******************************************************************

 created on:    01/10/2012 
 created by:    author
 last edit on:  $DateTime: $ 
 last edit by:  $Author: $
 revision:      $Revision: $
 comments:      Generated

******************************************************************
 //Project// (//Number//)

 This module implements the test bench for the myfpga.sv module.

	// enter detailed description here;


******************************************************************/
`timescale        1ns/1ps


module    test_myfpga        (//** Inputs **
                              input   logic         fpga_clk100_p,
                              input   logic         fpga_clk100_n,
                              input   logic [3:0]   fpga_data_out,

                              //** InOuts **

                              //** Outputs **
                              output  logic         fpga_board_rstn,
                              output  logic [3:0]   fpga_data_in
                             );

// *** Local Variable Declarations ***
// Local Parameter Declarations:
// N/A
// Local Logic Declarations:
// N/A
// Local Event Declarations:
event           start_Monitor;

// *** Local Integer Declarations ***
integer		results_file;	// for writing signal values

// initial block
initial
begin
	// initialize signals
        $display("Initialize Signals");
	fpga_board_rstn <= 0;
        fpga_data_in <= 4'b0;

        $display("Wait for 100 ns");
        #100
        ->start_Monitor;              //trigger routine to monitor 
        CpuReset;
	
        // open results file, write header
	results_file=$fopen("../out/top_results.txt");
	$fdisplay(results_file, " test_myfpga testbench results");
	$fwrite(results_file, "\n");
	DisplayHeader;
	
	// Add more test bench stuff here
        for(int i=0; i < 1024; i++)
        begin
            fpga_data_in <= i[3:0];
            @ (posedge fpga_clk100_p);
        end
	
	$fclose(results_file);
	$stop;
end

// Add more test bench stuff here as well
always 
begin: Monitor
  $timeformat(-9, 0, " ns", 9);
  @(start_Monitor)
  forever @(negedge fpga_clk100_p)
  begin
    $fstrobe(results_file,"At %t:    \t%h\t%h",$realtime, fpga_data_in, fpga_data_out);
  end
end


// Test Bench Tasks
task DisplayHeader;
  $fdisplay(results_file,"                       data_in      data_out ");
  $fdisplay(results_file,"                 ============================");
endtask    

task CpuReset;
begin
	@ (posedge fpga_clk100_p);
	fpga_board_rstn = 0;
	@ (posedge fpga_clk100_p);
	fpga_board_rstn = 1;
	@ (posedge fpga_clk100_p);
end
endtask

endmodule : test_myfpga



